/**
*   Nombre del Programa: Caminante_DATOS
*   Proyecto: Aplicacin Android de Asistencia al Caminante
*   Uso: captura coordenadas de sensores (acelerometro, orientacin)
    	 pasandolas a ficheros de texto	para su estudio.
**/    
/**    
    Copyright (C) 2011 Enrique Ramn Delgado Garrido

    This program is free software: you can redistribute it and/or modify 
    it under the terms of the GNU General Public License as published by 
    the Free Software Foundation, either version 3 of the License, or 
    (at your option) any later version. 

    This program is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
    GNU General Public License for more details. 

    You should have received a copy of the GNU General Public License 
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

package com.caminante.datos;

/** uso de singleton para tener una instancia de la clase en toda la aplicacin
*   en este caso lo referente a ficheros   
* @author Enrique Delgado
**/

public class MySingleton {
/**
 * 
 */
	private FicherosCAMINANTE	dataFiles = null;
	
/** definicin */
/**
 * 
 */
	private static	MySingleton	INSTANCE = null;
/**
 * 	
 */
	private			MySingleton()	{};
/**
 * 
 */
	private synchronized static void	createInstance() {
		if (INSTANCE == null) {
			INSTANCE = new MySingleton();
		}
	}
/**
 *         
 * @return INSTANCE
 */
	public static MySingleton getInstance() {
		if (INSTANCE == null) createInstance();
		return INSTANCE;
	}
	
/** get y set */
/**
 * 
 */
	public FicherosCAMINANTE getDataFile() {
		return this.dataFiles;
	}
/**
 * 
 * @param dataFile
 */
	public void setDataFile (FicherosCAMINANTE dataFile) {
		this.dataFiles = dataFile;
	}
}