/**
*   Nombre del Programa: Caminante_DATOS
*   Proyecto: Aplicacin Android de Asistencia al Caminante
*   Uso: captura coordenadas de sensores (acelerometro, orientacin)
    	 pasandolas a ficheros de texto	para su estudio.
**/    
/**    
    Copyright (C) 2011 Enrique Ramn Delgado Garrido

    This program is free software: you can redistribute it and/or modify 
    it under the terms of the GNU General Public License as published by 
    the Free Software Foundation, either version 3 of the License, or 
    (at your option) any later version. 

    This program is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
    GNU General Public License for more details. 

    You should have received a copy of the GNU General Public License 
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/
/**
*	


**/
package com.caminante.datos;

import java.util.List;

import com.caminante.datos.R;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.media.MediaPlayer;
import android.os.Bundle;
//import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

/**
* Esta clase Activity PantallaCAMINANTE constiruye el elemento inicial y principal de este programa
* muestra la pantalla y 
*	captura los dato de entrada - nombre del caminante 
*	getiona los botones y su estado - Inicio - Terminar
* usa las clases
*	FicherosCAMINANTE
*		gestiona los ficheros de texto que guardan los datos
*		crea y envia el coreeo adjuntando los ficheros
*	MySingleton
* gestina la utilizacin de los sensores
*
* @author Enrique Delgado
* 
**/

	public class PantallaCAMINANTE extends Activity implements OnClickListener {
/** variables de los elementos de la pantalla **/
		private	Button 				startButton		=	null;
		private	Button 				finishButton	=	null;
		private EditText			textName		=	null;	
/** variables para el almacenamiento del Nombre_del_caminante
 *  en -preferences- **/		
		private static final 	String 		DEFAULT_WALKER	= "Nombre";
		private		    		String		wALKER 			= DEFAULT_WALKER;
		private static final 	String 		KEY_WALKER		= "NOMBRE_CAMINANTE";
		private static final 	String 		PREFS 			= "caminante.prefs";
/** variable objeto de la clase FicherosCAMINANTE  
 *  para lo referente a los fcheros de almacenamiento **/
		private FicherosCAMINANTE 	dataFiles;
/** variables para los sensores **/
		private	SensorManager		sensorManager;
		private Sensor 				accelerometer;
		private Sensor 				orientation; 
		//public float[] 			coordenadasAceleracion 	= new float[3];
		//public float[] 			coordenadasOrientacion 	= new float[3];
		static	float[] 			coordinatesZero			= new float[3];
/** variable para el control del proceso **/
		private boolean				sensorrunning	= false;
/** variables para los sonidos **/
		private MediaPlayer 		mPStart;
		private MediaPlayer 		mPStop;
        
/**
 * Mdulo de incio de la Activity
 * @param savedInstanceState
 * @see #onCreate(Bundle savedInstanceState)
 */
		//@Override 
		public void onCreate(Bundle savedInstanceState) {
			// 
			super.onCreate(savedInstanceState);
			// capturar y visualizar la pantalla
			setContentView(R.layout.main);
			// mantener el nombre del caminante entre sesiones
			SharedPreferences settings = getSharedPreferences(PREFS, 0);
			wALKER  = settings.getString(KEY_WALKER,  DEFAULT_WALKER);
			// mdulo para inicilizar lo concerniente a al pantalla
			setScreen();
			// mdulo para inicilizar lo concerniente a los sensores
			setSensors();
			// uso de singleton para tener una instancia de la clase en toda la aplicacin
			// en este caso lo referente a ficheros
			MySingleton mySingleton = MySingleton.getInstance();
			dataFiles = mySingleton.getDataFile();
		}
/**
 * 
 */
		protected void setScreen() {
	
			this.startButton=(Button)findViewById(R.id.buttonStart);
			
			if(this.startButton!=null) {
				this.startButton.setOnClickListener(this);
				this.startButton.setEnabled(true);
			}	
				
			this.finishButton=(Button)findViewById(R.id.buttonFinish);
			
			if(this.finishButton!=null) {
				this.finishButton.setOnClickListener(this);
				this.finishButton.setEnabled(false);
			}
				
			// rea de texto	
			CharSequence cS_Walker = wALKER;
			wALKER = cS_Walker.toString();
			textName = (EditText)findViewById(R.id.editTextName);
			textName.setText(cS_Walker);
			//((EditText)findViewById(R.id.editTextName)).setText(cS_Walker);
		}
/**
 * 
 */
		protected void setSensors() {
	    	
			sensorManager = (SensorManager)getSystemService(Context.SENSOR_SERVICE);

			List<Sensor> list;
	    	
			//Obtencin del Sensor Acelermetro
			list=sensorManager.getSensorList(Sensor.TYPE_ACCELEROMETER);
			if (list.size()>0) accelerometer=list.get(0);
			
			//Obtencin del Sensor Orientacin
			list=sensorManager.getSensorList(Sensor.TYPE_ORIENTATION);
			if (list.size()>0) orientation=list.get(0);
			
		    for (int i=0;i<3;i++) {
				//coordenadasAceleracion[i]=0; 
				//coordenadasOrientacion[i]=0;
				coordinatesZero[i]=0;
			}
		}
			
/**
 * Gestor de los eventos Click
 */
		//@Override
		public void onClick(View vista) {
			// captura del nombre del caminante
			wALKER = ((EditText)findViewById(R.id.editTextName)).getText().toString();
			// almacenamiento del nombre con preferences
			SharedPreferences settings = getSharedPreferences(PREFS, 0);
			SharedPreferences.Editor editor = settings.edit();
			editor.putString(KEY_WALKER, wALKER);
			editor.commit();
			// 
			// Filtro de los controles
			// Botn de inicio de la captura de datos
			if(vista.getId()==R.id.buttonStart) {
				sensorrunning = true;
				//paso del nombre del caminante para su uso en la clase 
				// FicherosCAMINANTE - uso de un constructor -ficticio-
				dataFiles = new FicherosCAMINANTE(wALKER, 0);
				// Llamada al constructor -real- de FicherosCAMINANTE
				dataFiles = new FicherosCAMINANTE(this);
				// uso de Singleton
				MySingleton mySingleton = MySingleton.getInstance();
				mySingleton.setDataFile(dataFiles);
				// Lanzar el proceso de escucha de los sensores
				onResumeSensors();
				// tratar elementos de pantalla
				this.startButton.setEnabled(false);   //DESACTIVADO
				this.finishButton.setEnabled(true);   //ACTIVADO
				this.textName.setEnabled(false);
				// emitri sonido de inicio
				MyPlayerStart(getBaseContext());
                mPStart.start();
			}
			// Botn de terminacin el proceso de captura de datos
			if(vista.getId()==R.id.buttonFinish) {
				sensorrunning = false;
				stopProcess();
				// emite el sonido de cierre
				MyPlayerStop(getBaseContext());
                mPStop.start();
                // termina la aplicacin
                finish();
			}
		}
/** mdulo para el comienzo real del uso de los sensores por parte del programa
 * 
 */
		//@Override
		protected void onResumeSensors() {

			super.onResume();

			//Registro de los escuchadores 
			if (accelerometer!=null) {
				sensorManager.registerListener(sensorEventListener, 
						//acelerometro,SensorManager.SENSOR_DELAY_NORMAL);
						accelerometer,SensorManager.SENSOR_DELAY_FASTEST);
			}

			if (orientation!=null) {
				sensorManager.registerListener(sensorEventListener, 
						//orientacion,SensorManager.SENSOR_DELAY_NORMAL);
						orientation,SensorManager.SENSOR_DELAY_FASTEST);
			}
		}
/** mdulo para la recepcin de los valores de los sensores cusndo se detecta
 *  un evento de cambio en dichos valores
 */
		private SensorEventListener sensorEventListener = new SensorEventListener() {
			// variables de coordenadas
			public	float[] coordinatesAccelerometer 	= new float[3];
			public  float[] coordinatesOrientation 		= new float[3];
			// modulo para capturar los eventos de cambio de precisin
			// no se usa
			//@Override
			public void onAccuracyChanged(Sensor sensor, int accuracy) {
				// TODO Auto-generated method stub
			}
			// modulo para capturar los eventos de cambio de valor
			//@Override
			public void onSensorChanged(SensorEvent event) {
				
				//implantacin de los escuchadores que sincronizamos
		    	synchronized (this) {
		    		//damos formato de nmero float a los valores de los eventos
		    		for (int i=0;i<3;i++) {
		    			int w=(int)(10*event.values[i]);
		    			event.values[i]=(float)(w/10.0f);
		    		}
		    		//actualizacin de los valores dependiendo del tipo de sensor
		    		if (event.sensor==accelerometer) {
		    			this.setAccelerometer(event.values);
		    			//escritura los dato en el fichero del acelermetro
		    			// por medio del objeto de la clase FicherosCAMINANTE
		    			dataFiles.addDatoACEL(coordinatesAccelerometer[0], 
		    								  coordinatesAccelerometer[1], 
		    								  coordinatesAccelerometer[2]);
		    		} else {
		    			this.setAccelerometer(coordinatesZero);
		    		}
		    		if (event.sensor==orientation) {
		    			this.setOrientacion(event.values);
		    			//escritura los dato en el fichero de orientacin
		    			// por medio del objeto de la clase FicherosCAMINANTE
		    			dataFiles.addDatoORIE(coordinatesOrientation[0], 
		    								  coordinatesOrientation[1],
				   	   		 				  coordinatesOrientation[2]);
		    		} else {
		    			this.setOrientacion(coordinatesZero);
		    		}
		    	}
			}
			public void setAccelerometer (float[] coordinates) {
				this.coordinatesAccelerometer=coordinates;
				} 

			public void setOrientacion(float[] coordinates) {
				this.coordinatesOrientation=coordinates;
				}
		};
		
		protected void stopProcess() {
			// elimina de escucha los sensores
			sensorManager.unregisterListener(sensorEventListener);
			// uso del Singleton
			MySingleton mySingleton = MySingleton.getInstance();
			dataFiles = mySingleton.getDataFile();
			// cierra los ficheros (y lanza el correo)
			dataFiles.fileClose(this);
		}
/**
 * 
 * @param mPctx
 */
		public void MyPlayerStart(Context mPctx) {
			mPStart = new MediaPlayer();
			mPStart = MediaPlayer.create(mPctx, R.raw.tick);
		}
/**
 * 
 * @param mPctx
 */
		public void MyPlayerStop(Context mPctx) {
			mPStop = new MediaPlayer();
			mPStop = MediaPlayer.create(mPctx, R.raw.tock);
		}
/** mdulo para las paradas fuera del botn terminar
 * 
 */
		protected void onDestroy() {
			super.onDestroy();
			if (sensorrunning) {
				stopProcess();
				//sensorManager.unregisterListener(sensorEventListener);
			}
		}
}
